function generateQuery(side,dataset){
	var predicate = $('#sel_' + side + 'Predicate').val(); 	
	var sparqlQuery = "";

	var isRefinedQuery = 0;
	if($('#cb_' + side + 'RefineSearch').is(':checked'))
		isRefinedQuery = 1;

	//makes sure {<,>} are not mucking up the query
	var speechMarks = "\"";
	if($('#sel_' + side + 'PredicateValue').val().substring(0,1)=="<") speechMarks="";

    var refineDataset = "GRAPH gsdl:" + dataset + " {\n";
	if(isRefinedQuery == 0)	
		sparqlQuery += "SELECT (?o as ?Objects) (COUNT (?o) as ?Count) WHERE {\n" +
					"  " + refineDataset +
					"    ?s <" + predicate + "> ?o\n } \n}\n";
	else
    	sparqlQuery += "SELECT (?o as ?Objects) (COUNT (?o) as ?Count) WHERE {\n" +
                   "  " + refineDataset +
                   "    ?s <"+ predicate + "> "+ speechMarks + $('#sel_' + side + 'PredicateValue').val() + speechMarks +";\n" + 
                   "      <"+$('#sel_' + side + 'VisualizePredicate').val() +"> ?o\n}\n}\n" ;
    sparqlQuery +=  "GROUP BY ?o ORDER BY DESC(?Count)\n";

    if($('#sel_' + side + 'Limit').val()!="None")
        sparqlQuery += " LIMIT " + $('#sel_' + side + 'Limit').val();
	else
        sparqlQuery += " LIMIT " + hardLimit;
		
	return(sparqlQuery);
}

function generateComparisonQuery(){

	var query = comparisonQuery;
	var predOut= $('#sel_comparisonPredicate').val();
	var comparisonMethod = $('#sel_comparisonMethod').val();

	//Start generating query
    	var sparqlQuery = "";
	var sparqlQueryHeader = "";
	///////INTERSECTION///////
	if(query.type=="intersection"){
		sparqlQueryHeader 	+= 	"SELECT DISTINCT ?common ";

		sparqlQuery 		+= 	"GRAPH gsdl:" + leftCollection + "{" ;
		if(query.refine_L!="")
			sparqlQuery 	+= 	"	?s <" + query.pred_L + "> \"" + query.predval_L + "\";" + 
								query.refine_L;
		else
			sparqlQuery 	+=	"	?s <" + query.pred_L + "> "// ?common;"; 
			
		sparqlQuery += generateFilter("left", comparisonMethod);

		if(!$('#cb_showOnlyCommonObjects').is(':checked')){
			if($('#sel_comparisonPredicate').val()!=""){
				var objName = "?Left_" + $('#sel_comparisonPredicate option:selected').text().replace(/\./g, '_');
				sparqlQuery		+= 	"OPTIONAL{ ?s  <" + $('#sel_comparisonPredicate').val() + "> " + objName + "}"; 
				sparqlQueryHeader+= objName + " ";
			}
			if($('#sel_comparisonPredicate1').val()!=""){
				var objName = "?Left_" + $('#sel_comparisonPredicate1 option:selected').text().replace(/\./g, '_');
				sparqlQuery		+= 	"OPTIONAL{ ?s  <" + $('#sel_comparisonPredicate1').val() + "> " + objName + "}"; 
				sparqlQueryHeader+= objName + " ";
			}
			if($('#sel_comparisonPredicate2').val()!=""){
				var objName = "?Left_" + $('#sel_comparisonPredicate2 option:selected').text().replace(/\./g, '_');
				sparqlQuery		+= 	"OPTIONAL{ ?s  <" + $('#sel_comparisonPredicate2').val() + "> " + objName + "}"; 
				sparqlQueryHeader+= objName + " ";
			}
		}

		sparqlQuery 		+=	"}" + 
								"GRAPH gsdl:" + rightCollection +"{";
		if(query.refine_R!="")
			sparqlQuery 	+=	"	?s1 <" + query.pred_R + "> \"" + query.predval_R + "\";" + 
								query.refine_R;
		else
			sparqlQuery 	+=	"	?s1 <" + query.pred_R + "> "// ?common;" ; 

		sparqlQuery += generateFilter("right", comparisonMethod);

		if(!$('#cb_showOnlyCommonObjects').is(':checked')){
			if($('#sel_comparisonPredicate').val()!=""){
				var objName = "?Right_" + $('#sel_comparisonPredicate option:selected').text().replace(/\./g, '_');
				sparqlQuery		+= 	"OPTIONAL{ ?s1  <" + $('#sel_comparisonPredicate').val() + "> " + objName + "}"; 
				sparqlQueryHeader+= objName + " ";
			}
			if($('#sel_comparisonPredicate1').val()!=""){
				var objName = "?Right_" + $('#sel_comparisonPredicate1 option:selected').text().replace(/\./g, '_');
				sparqlQuery		+= 	"OPTIONAL{ ?s1  <" + $('#sel_comparisonPredicate1').val() + "> " + objName + "}"; 
				sparqlQueryHeader+= objName + " ";
			}
			if($('#sel_comparisonPredicate2').val()!=""){
				var objName = "?Right_" + $('#sel_comparisonPredicate2 option:selected').text().replace(/\./g, '_');
				sparqlQuery		+= 	"OPTIONAL{ ?s1  <" + $('#sel_comparisonPredicate2').val() + "> " + objName + "}"; 
				sparqlQueryHeader+= objName + " ";
			}
		}
	
		sparqlQuery 		+=	"}" + 
								"FILTER (?common!=\"\")" +
								"}";
		sparqlQuery 		+= "ORDER BY DESC (?common)"
	}
	

    //////MINUS/////
	if(query.type=="minus"){
		sparqlQueryHeader 	+= 	"SELECT DISTINCT ?minus " ;

		var subj;
		if(query.datasetSelection==leftCollection){
			sparqlQuery		+=	"GRAPH gsdl:" + leftCollection + "{   ?s <" + query.pred_L + "> ?minus;"
			subj = "?s ";
		}
		else{
			sparqlQuery		+=	"GRAPH gsdl:" + rightCollection +"{   ?s1 <" + query.pred_R + "> ?minus;";
			subj = "?s1 ";
		}

		if(!$('#cb_showOnlyCommonObjects').is(':checked')){
			if($('#sel_comparisonPredicate').val()!=""){
				var objName = "?" + $('#sel_comparisonPredicate option:selected').text().replace(/\./g, '_');
				sparqlQuery		+= 	"OPTIONAL{ " + subj + "  <" + $('#sel_comparisonPredicate').val() + "> " + objName + "}"; 
				sparqlQueryHeader+= objName + " ";
			}
			if($('#sel_comparisonPredicate1').val()!=""){
				var objName = "?" + $('#sel_comparisonPredicate1 option:selected').text().replace(/\./g, '_');
				sparqlQuery		+= 	"OPTIONAL{ " + subj + "  <" + $('#sel_comparisonPredicate1').val() + "> " + objName + "}"; 
				sparqlQueryHeader+= objName + " ";
			}
			if($('#sel_comparisonPredicate2').val()!=""){
				var objName = "?" + $('#sel_comparisonPredicate2 option:selected').text().replace(/\./g, '_');
				sparqlQuery		+= 	"OPTIONAL{ " + subj + "  <" + $('#sel_comparisonPredicate2').val() + "> " + objName + "}"; 
				sparqlQueryHeader+= objName + " ";
			}
		}
		
		sparqlQuery			+=	"} ";
		sparqlQuery 		+= 	"MINUS{" 
					 		+ 	"GRAPH gsdl:" + leftCollection + "{" ;
		if(query.refine_L!="")
			sparqlQuery 	+= 	"	?s <" + query.pred_L + "> \"" + query.predval_L + "\";"  
							+	query.refine_L;
		else
			sparqlQuery 	+=	"	?s <" + query.pred_L + "> "; 

		sparqlQuery += generateFilter("left", comparisonMethod)
		sparqlQuery 		+=	"}"  
							+	"GRAPH gsdl:" + rightCollection +"{";
		if(query.refine_R!="")
			sparqlQuery 	+=	"	?s1 <" + query.pred_R + "> \"" + query.predval_L + "\";" 
							+	query.refine_L;
		else
			sparqlQuery 	+=	"	?s1 <" + query.pred_R + "> " ; 

		sparqlQuery += generateFilter("right", comparisonMethod)
		sparqlQuery 		+=	"}"  
							+	"}}";
	}
	sparqlQuery = sparqlQueryHeader + "  WHERE{" + sparqlQuery;
	sparqlQuery += "LIMIT " + $('#sel_comparisonLimit').val() + " ";
	sparqlQuery += "OFFSET " + ((query.page-1) * $('#sel_comparisonLimit').val()); 
	console.log(sparqlQuery);
	return sparqlQuery;
} 

function generateFilter(side, comparisonMethod){
	var query = "";
	var tempVar;
	if(side == "left")
		tempVar = "a";
	else if(side == "right")
		tempVar = "b";
	else if(side == "minus")
		tempVar = "x";
	switch(comparisonMethod){
		case "exact":
			query	+= 	"?common;";
			break;
		case "10numeric":
			query	+= 	"?"+tempVar + "; "
					+	"BIND (REPLACE (?o, \"\\\\D\",\"\") as ?" + tempVar + "1) "
					+	"BIND (xsd:integer(SUBSTR (?" + tempVar + "1, 1, 10)) as ?common) ";
			break;
		case "numeric":
			query	+= 	"?" + tempVar + "; ";
			if(side == "minus")
				query	+=	"BIND (REPLACE (?" + tempVar + ", \"\\\\D\",\"\") as ?minus) ";
			else
				query	+=	"BIND (REPLACE (?" + tempVar + ", \"\\\\D\",\"\") as ?common) ";
			break;
		case "10char":
			query 	+=	"?" + tempVar + "; ";
			if(side == "minus")
				query	+=	"BIND (SUBSTR(?" + tempVar + ", 0,10) as ?minus) ";
			else
				query	+=	"BIND (SUBSTR(?" + tempVar + ", 0,10) as ?common) ";
			break;
		case "minus":
			query	+= 	"?minus;";
			break;
		default:
			break;	
	}
	return query;
}



function updateValueSelector(predicate, selector, collectionName){
    var refineDataset = "GRAPH gsdl:" + collectionName + " {\n";
    var sparqlQuery = "PREFIX gsdl: <http://localhost:3030/greenstone/data/> \n";
	    sparqlQuery += "SELECT ?obj WHERE{"+
						  refineDataset +  
						  "   ?s <"+predicate+"> ?obj }}"+
						  "GROUP BY ?obj ORDER BY (?obj)"+
						  "LIMIT 1000";
	var ajaxSparqlQuery = sparqlEndpoint + "?query=" + encodeURIComponent(sparqlQuery);
	currentQueries++;
	setCursor("wait");		

	$.ajax({
		url: ajaxSparqlQuery,
		type:"GET",
		data:"output=json",
	})
	.done(function( json ) {
		var parsedJSON = ((typeof json) == "string") ? $.parseJSON(json) : json;

		//Clear selector. Add empty option to start.
		var valueSelector = $('#' + selector);
		valueSelector.empty();
		valueSelector
		.append("<option value=\"None\">  </option>");

		$.each(parsedJSON.results.bindings,function(index,item){
			var obj;
			if(item.obj.type == "uri"){
				obj = "&lt;" + item.obj.value + "&gt;";
				valueSelector	
					.append("<option value="+ obj + ">" + obj.substring(0,75) + "</option>");
			}
			else{
				obj = item.obj.value;
				valueSelector
					.append("<option value=\""+ obj +"\">" + obj.substring(0,75) + "</option>");
			}
		});
		valueSelector.next().find('.custom-combobox-input').val("");
		if(--currentQueries == 0)
			setCursor("");		
	});
}

function updateVisualizePredicateSelector(predicate,value,selector,collection){
	var sparqlQuery;
	if(value.substring(0,1) == "<") 
    sparqlQuery = "SELECT ?predicate WHERE{"+
                      "   ?s <" + predicate + ">  "+ value + ";"+
                      "      ?predicate ?o}"+
                      "GROUP BY ?predicate ORDER BY DESC(?predicate)";
	else
    sparqlQuery = "SELECT ?predicate WHERE{"+
                      "   ?s <" + predicate + ">  \""+ value + "\";"+
                      "      ?predicate ?o}"+
                      "GROUP BY ?predicate ORDER BY DESC(?predicate)";

    var ajaxSparqlQuery = sparqlEndpoint + "?query=" + encodeURIComponent(sparqlQuery);
	currentQueries++;
	setCursor("wait");		

    $.ajax({
        url: ajaxSparqlQuery,
        type:"GET",
        data:"output=json",
    })
    .done(function( json ) {
        var parsedJSON = ((typeof json) == "string") ? $.parseJSON(json) : json;
		var dropdown = $('#' + selector);
        dropdown.empty();
		dropdown	
		.append("<option value=\"None\">  </option>");
        $.each(parsedJSON.results.bindings,function(index,item){
            var pred = item.predicate.value;
            var name = tidyPredicate(pred);
            dropdown
                .append("<option value=\""+pred+"\">" + name + "</option>");
        });
		dropdown.next().find('.custom-combobox-input').val("");
		if(--currentQueries == 0)
			setCursor("");		
    });
}

function drawFilteredDataset(side, collection){
	var Q = new sgvizler.Query();
	Q.query(generateQuery(side, collection))
		.endpointURL(sparqlEndpoint)
		.endpointOutputFormat("json")
		.chartFunction($('#sel_' + side + 'ChartType').val())
		.draw("div_" + side + "FilteredDataset");

}

function drawComparisonTable(){
	sgvizler.defaultChartWidth("auto");
	sgvizler.defaultChartHeight(280);
	var Q = new sgvizler.Query();
	Q.query(generateComparisonQuery())
		.endpointURL(sparqlEndpoint)
		.endpointOutputFormat("json")
		.chartFunction("google.visualization.Table")
		.draw("div_combinedResultsVisualization");
	sgvizler.defaultChartWidth(defaultChartWidth);
	sgvizler.defaultChartHeight(defaultChartHeight);

/*	var ajaxSparqlQuery = sparqlEndpoint + "?query=" + encodeURIComponent(generateComparisonQuery());

	$('#table_combinedResults').jqGrid({
		url: ajaxSparqlQuery,
		datatype: "spreadsheet",
		colNames: ['Common'],
		colModel: [{name: 'common',
					index: 'results.bindings.common',
					width: '300'}],
		rowNum: 10,
		rowList: [10,20,30],
		pager: '#table_combinedResultsPager',
//		sortname: 'common',
		viewrecords: true,
		sortorder: 'desc',
		caption: 'Results table'
	});
	$('#table_combinedResults').jqGrid('navGrid','#div_combinedResultsPager',{edit:false, add:false, del:false});

*/	
}

function tidyPredicate(name){
	name = name.replace("http://purl.org/dc/elements/1.1/","dc.");
	name = name.replace("http://purl.org/ontology/bibo/","bibo.");
	name = name.replace("http://greenstone.org/gsembedded#","gsembedded.");
	name = name.replace("http://greenstone.org/gsextracted#","gsextracted.");
	return name;
}
//Fills the predicate selector with values
function populatePredicateSelector(collection, selector){
	$('#' + selector).empty();
	if(selector=="sel_comparisonPredicate"){
		$('#' + selector + "1")
			.empty()
			.append("<option value=\"\"> </option>");
		$('#' + selector + "2")
			.empty()
			.append("<option value=\"\"> </option>");
	}

	var ajaxSparqlQuery = sparqlEndpoint + "?query=" + encodeURIComponent(createOverviewQuery(collection));
	currentQueries++;
	setCursor("wait");		
	$.ajax({
		url: ajaxSparqlQuery,
		type:"GET",
		data:"output=json",
	})
	.done(function( json ) {
		var parsedJSON = ((typeof json) == "string") ? $.parseJSON(json) : json;
		$.each(parsedJSON.results.bindings,function(index,item){
			if(typeof(item.Predicate)!="undefined"){
				if(selector=="sel_leftPredicate" || selector == "sel_rightPredicate"){
					var side = selector.substring(0, selector.indexOf("P"));
					var pred  = item.Predicate.value;
					var name = tidyPredicate(pred);
					$('#' + selector)
						.append("<option value=\""+pred+"\">" + name + "</option>");
					$('#' + side + "VisualizePredicate")
						.append("<option value=\""+pred+"\">" + name + "</option>");

				}
				else{
					var pred  = item.Predicate.value;
					var name = tidyPredicate(pred);
					$('#' + selector)
						.append("<option value=\""+pred+"\">" + name + "</option>");
					$('#' + selector + "1")
						.append("<option value=\""+pred+"\">" + name + "</option>");
					$('#' + selector + "2")
						.append("<option value=\""+pred+"\">" + name + "</option>");
				}
			}
		});
		if(--currentQueries == 0)
			setCursor("");		
	});
}

function setCursor(style){
	console.log("Cursor: " + style);
	document.body.style.cursor = style;
}
